Subject: bug#8938: make timeout and CTRL-C

From: "Alan Curry" <[email-masked]>
Date: Tue, 28 Jun 2011 14:10:47 -0500 (GMT+5)

=?ISO-8859-1?Q?P=E1draig_Brady?= writes:
> 
> I'm still not convinced we need to be messing with tcsetpgrp()
> but you're right in that the disconnect between the timeout
> process group and that of whatever starts `timeout` should be bridged.
> 
> I'm testing the attached patch at the moment (which I'll split into 2).
> It only creates a separate group for the child that `timeout` execs,
> leaving the timeout process in the original group to propagate signals down.
> 
> I'll need to do lots of testing with this before I commit.

With this patch the child is guaranteed to not be in the foreground (as far
as the tty knows) so it will be getting SIGTTIN and possibly SIGTTOU on tty
operations.

I don't think there's anything that will make every scenario happy. (Except
for a recursive-kill that doesn't use pgrps!).

-- 
Alan Curry